#include <ell/CS_LP_PivotM_StructCUBNorm.hh>
#include <fstream>	// for readBinaryInputClone(..), writeBinaryOutput(..)

namespace ell
{
	CS_LP_PivotM_StructCUBNorm::CS_LP_PivotM_StructCUBNorm(
	 const biu::Structure& normStruc) {
	cStructure = compressSeq(normStruc,
							 S_LP_PivotM_StructCUBNorm::
							  getCommonCUBLatticeModel()->getDescriptor()
							  ->getAlphabet());
	}

	CS_LP_PivotM_StructCUBNorm::
	~CS_LP_PivotM_StructCUBNorm() {
	}

	std::string
	CS_LP_PivotM_StructCUBNorm::getUncompressedSeqStr() const {
		return S_LP_PivotM_StructCUBNorm::
				 getCommonSequenceString();
	}

	std::string
	CS_LP_PivotM_StructCUBNorm::getUncompressedStructStr() const {
			// structure string holds one character less than sequence string
		return uncompressSeq(cStructure,
							  S_LP_PivotM_StructCUBNorm::
							  getCommonCUBLatticeModel()->getDescriptor()
							   ->getAlphabet(),
							  S_LP_PivotM_StructCUBNorm::
							   getCommonSequenceString().size()-1);
	}

	bool	
	CS_LP_PivotM_StructCUBNorm::operator== (const CState& _cState2) const {
		CS_LP_PivotM_StructCUBNorm cState2 =
		 dynamic_cast<const CS_LP_PivotM_StructCUBNorm&>(_cState2);
		return (this->cStructure == cState2.cStructure);
	}

	bool
	CS_LP_PivotM_StructCUBNorm::operator!= (const CState& _cState2) const {
		CS_LP_PivotM_StructCUBNorm cState2 =
		 dynamic_cast<const CS_LP_PivotM_StructCUBNorm&>(_cState2);
		return (this->cStructure != cState2.cStructure);
	}

	CS_LP_PivotM_StructCUBNorm* 
	CS_LP_PivotM_StructCUBNorm::clone() const {
		return new CS_LP_PivotM_StructCUBNorm(*this);
	}

	std::string
	CS_LP_PivotM_StructCUBNorm::getCStateStringRepresentation() const {
		std::string strRepr;
		for (size_t i = 0; i < cStructure.size(); i++) {
			strRepr += cStructure[i];
		}
		return strRepr;
	}

	std::string
	CS_LP_PivotM_StructCUBNorm::getUncomprStateStringRepresentation()
	 const {
		return getUncompressedStructStr();
	}

	State*
	CS_LP_PivotM_StructCUBNorm::uncompressedClone() const {
		return new S_LP_PivotM_StructCUBNorm(
					 getUncompressedStructStr(), false);
	}

	void
	CS_LP_PivotM_StructCUBNorm::uncompress(State& state) const {
		dynamic_cast<S_LP_PivotM_StructCUBNorm&>(state) =
		 S_LP_PivotM_StructCUBNorm(getUncompressedStructStr(),
		  false);
	}

	CS_LP_PivotM_StructCUBNorm*
	CS_LP_PivotM_StructCUBNorm::readBinaryInputClone(std::ifstream& source)
	 const {

			// create new CS_LP_PivotM_StructCUBNorm
		CS_LP_PivotM_StructCUBNorm* cState =
		 new CS_LP_PivotM_StructCUBNorm();

		size_t size;

			// read cStructure
		source.read(reinterpret_cast<char*>(&size), sizeof(size));
		cState->cStructure.resize(size);
		for (size_t i = 0; i < cState->cStructure.size(); i++) {
			source.read(reinterpret_cast<char*>(&(cState->cStructure[i])),
						  sizeof(cState->cStructure[i]));
		}

		return cState;
	}

	void
	CS_LP_PivotM_StructCUBNorm::writeBinaryOutput(std::ofstream& destination)
	 const {
			// write cStructure
		size_t size = cStructure.size();
		destination.write(reinterpret_cast<const char*>(&size), sizeof(size));
		for (size_t i = 0; i < size; i++) {
			destination.write(reinterpret_cast<const char*>(&(cStructure[i])),
							   sizeof(cStructure[i]));
		}
	}

} // namespace ell
