#include <ell/CS_RNAfe_SingleM_Struct.hh>
#include <fstream>	// for readBinaryInputClone(..)

namespace ell
{

	CS_RNAfe_SingleM_Struct::CS_RNAfe_SingleM_Struct(
	 const biu::Structure& struc) {
		cStructure = compressSeq(struc, RNAFreeEnergy::getStructureAlphabet());
	}

	CS_RNAfe_SingleM_Struct::
	~CS_RNAfe_SingleM_Struct() {
	}

	std::string
	CS_RNAfe_SingleM_Struct::getUncompressedSeqStr() const {
		return S_RNAfe_SingleM_Struct::getCommonSequenceString();
	}

	std::string
	CS_RNAfe_SingleM_Struct::getUncompressedStructStr() const {
		return uncompressSeq(cStructure,RNAFreeEnergy::getStructureAlphabet(),
							  S_RNAfe_SingleM_Struct::
							  getCommonSequenceString().size());
	}

	bool	
	CS_RNAfe_SingleM_Struct::operator== (const CState& _cState2) const {
		CS_RNAfe_SingleM_Struct cState2 =
		 dynamic_cast<const CS_RNAfe_SingleM_Struct&>(_cState2);
		return this->cStructure == cState2.cStructure;
	}

	bool	
	CS_RNAfe_SingleM_Struct::operator!= (const CState& _cState2) const {
		CS_RNAfe_SingleM_Struct cState2 =
		 dynamic_cast<const CS_RNAfe_SingleM_Struct&>(_cState2);
		return this->cStructure != cState2.cStructure;
	}

	CS_RNAfe_SingleM_Struct* 
	CS_RNAfe_SingleM_Struct::clone() const {
		return new CS_RNAfe_SingleM_Struct(*this);
	}

	std::string
	CS_RNAfe_SingleM_Struct::getCStateStringRepresentation()
	 const {
		std::string strRepr;
		for (size_t i = 0; i < cStructure.size(); i++) {
			strRepr += cStructure[i];
		}
		return strRepr;
	}

	std::string
	CS_RNAfe_SingleM_Struct::getUncomprStateStringRepresentation()
	 const {
		return getUncompressedStructStr();
	}

	State*
	CS_RNAfe_SingleM_Struct::uncompressedClone() const {
		return new S_RNAfe_SingleM_Struct(
					 getUncompressedStructStr());
	}

	void
	CS_RNAfe_SingleM_Struct::uncompress(State& state) const {
		dynamic_cast<S_RNAfe_SingleM_Struct&>(state) =
		 S_RNAfe_SingleM_Struct(getUncompressedStructStr());
	}

	CS_RNAfe_SingleM_Struct*
	CS_RNAfe_SingleM_Struct::readBinaryInputClone (
	 std::ifstream& source) const {

			// create new CS_RNAfe_SingleM_Struct
		CS_RNAfe_SingleM_Struct* cState =
		 new CS_RNAfe_SingleM_Struct();

		size_t size;

			// read cStructure
		source.read(reinterpret_cast<char*>(&size), sizeof(size));
		cState->cStructure.resize(size);
		for (size_t i = 0; i < cState->cStructure.size(); i++) {
			source.read(reinterpret_cast<char*>(&(cState->cStructure[i])),
						  sizeof(cState->cStructure[i]));
		}

		return cState;
	}

	void
	CS_RNAfe_SingleM_Struct::writeBinaryOutput(
	 std::ofstream& destination) const {
			// write cStructure
		size_t size = cStructure.size();
		destination.write(reinterpret_cast<const char*>(&size), sizeof(size));
		for (size_t i = 0; i < size; i++) {
			destination.write(reinterpret_cast<const char*>(&(cStructure[i])),
							   sizeof(cStructure[i]));
		}
	}

} // namespace ell
