
#include "WalkAbortionCriterion.hh"

using namespace ell;

WAC_MaxLength::WAC_MaxLength(unsigned int max)
{
	maxStates = max;
}

bool
WAC_MaxLength::abort(WalkCollector* wc)
{
	if (wc->getAcceptedCount() > maxStates)
		return true;
	else
		return false;
}

WAC_MaxEnergy::WAC_MaxEnergy(double max)
{
	maxEnergy = max;
}

bool
WAC_MaxEnergy::abort(WalkCollector* wc)
{
	if (wc->getLastState()->getEnergy() >= maxEnergy)
		return true;
	else
		return false;
}

WAC_MinEnergy::WAC_MinEnergy(double min)
{
	minEnergy = min;
}

bool
WAC_MinEnergy::abort(WalkCollector* wc)
{
	if (wc->getLastState()->getEnergy() <= minEnergy)
		return true;
	else
		return false;
}

WAC_OpenEnd::WAC_OpenEnd() {}

bool
WAC_OpenEnd::abort(WalkCollector* wc) { return false; } 
