#include "walkAdaptive.hh"
#include "walk.hh"
#include "StateAcceptor.hh"

namespace ell {
	
	WalkCollector* walkAdaptive(
			State* s, 
			WalkCollector* wc,
			NeighborGenType t)
	{
		// Decide which kind of NeighborGenerator to use
		NeighborGenerator* ng;
		if (t==RANDOM) ng = new NG_Random();
		else if (t==SUCCESSIVE)	ng = new NG_Successive();
		
		// Succesor State mus have lesser energy
		StateAcceptor* sa = new SA_E_Le();
		
		// An adaptive walk is always finished at a local minimum,
		// there is no additional abortion criterion
		WalkAbortionCriterion* wac = new WAC_OpenEnd();
		
		wc = walk(s, ng, sa, wac, wc);
		
		delete ng;
		delete sa;
		delete wac;
		
		return wc;
	}
	
} // end namespace ell
