#ifndef WALKADAPTIVE_HH_
#define WALKADAPTIVE_HH_

#include "State.hh"
#include "NeighborGenerator.hh"
#include "WalkAbortionCriterion.hh"
#include "WalkCollector.hh"

namespace ell {

enum NeighborGenType {SUCCESSIVE, RANDOM};
	
/*!
 * This function implements an adaptive walk starting from State s
 * by executing ell::walk.
 * 
 * @author Daniel Maticzka
 */
WalkCollector* walkAdaptive(
		State* s,
		WalkCollector* wc,
		NeighborGenType t);
		
} // end namespace ell

#endif /*WALKADAPTIVE_HH_*/
