#include "walkGradient.hh"

namespace ell {

WalkCollector * walkGradient(State* s, WalkCollector* wc) {
	
	s = s->clone();
	
	while (true) {
		double threshold = s->getEnergy();
		
		State::NeighborListPtr neighbors = s->getNeighborList();
		State::NeighborList::Iterator it = neighbors->begin();

		// look for best neighbor
		while (neighbors->end() != it) {
			if ((*it).getEnergy() < threshold) {
				delete s;
				s = (*it).clone();
			}
			++it;
		}
		
		if (s->getEnergy() < threshold) {
			// found new gradient neighbor 
			wc->setAccepted(*s);
		}
		else {
			// found local minimum 
			delete s;
			break;
		}
	}
	
	return wc;
}

} // end namespace ell
