#ifndef WALKMC_HH_
#define WALKMC_HH_

#include "State.hh"
#include "WalkCollector.hh"

namespace ell {
	/*!
	 * This function implements a Monte Carlo walk using the Metropolis
	 * criterion parametrized by beta.
	 *  
	 * @author Daniel Maticzka
	 */
	WalkCollector* walkMC(
		State* s, WalkCollector* wc, double beta);
} // end namespace ell

#endif /*WALKMC_HH_*/
